/*
 * Copyright (c) 2011-2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import bb.cascades 1.3
import bb.data 1.0
import bb.system 1.0
import bb.cascades.pickers 1.0


        Page {
            id: pgSeznam
            property int poradi;
            titleBar: TitleBar {
                title: qsTr("Contact Event") + Retranslate.onLocaleOrLanguageChanged
                appearance: TitleBarAppearance.Branded
            
            }     
            Container {
                ScrollView {
            id: swCall
            visible: true
            Container {
                        property real margins: ui.du(3)
                        
                        
                        topPadding: margins
                        leftPadding: margins
                        rightPadding: margins
                        bottomPadding: margins
                        
                        Divider {
                        
                        }

                Button {
                    text: qsTr("Choose a contact ") + Retranslate.onLanguageChanged
                    onClicked: {
                        vyberKontakt.open();
                    }
                    horizontalAlignment: HorizontalAlignment.Center
                    color: Color.Blue
                }
               
                DateTimePicker {
                            id: pomdp1
                            mode: DateTimePickerMode.DateTime
                            accessibilityMode: A11yMode.Collapsed
                            title: qsTr("Event from: ") + Retranslate.onLanguageChanged
                    onValueChanged: {
                        pomdp2.value = _calendar.ZvysDatum(pomdp1.value, app.read("EventLength",60)*60);
                        if (pomdp2.value > pomdp1.value) {btEvent.enabled = true;} else {btEvent.enabled = false;};
                    }
                }
                        DateTimePicker {
                            id: pomdp2
                            mode: DateTimePickerMode.DateTime
                            accessibilityMode: A11yMode.Collapsed
                            title: qsTr("Event to: ") + Retranslate.onLanguageChanged
                    onValueChanged: {
                        if (pomdp2.value > pomdp1.value) {btEvent.enabled = true;} else {btEvent.enabled = false;};
                    }
                }
                        Divider {
                        
                        }
                        Container {
                            layout: StackLayout {
                                orientation: LayoutOrientation.LeftToRight
                            
                            }
                            verticalAlignment: VerticalAlignment.Center
                            Label {
                                text: qsTr("Event subject:") + Retranslate.onLanguageChanged
                                verticalAlignment: VerticalAlignment.Center

                    }
                            TextField {
                                id: tfSubject
                        verticalAlignment: VerticalAlignment.Center

                    }
                        }
                        Divider {
                        
                        }
                        Container {
                            layout: StackLayout {
                                orientation: LayoutOrientation.LeftToRight
                            
                            }
                            verticalAlignment: VerticalAlignment.Center
                            Label {
                                text: qsTr("Phone number:") + Retranslate.onLanguageChanged
                                verticalAlignment: VerticalAlignment.Center

                    }
                            TextField {
                                id: tfNumber
                        verticalAlignment: VerticalAlignment.Center

                    }
                    //pomocny combobox
                    
                        }
                        DropDown {
                            id: ddCislo
                            visible: false
                            onSelectedIndexChanged: {
                                tfNumber.text = ddCislo.selectedOption.text
                                ddCislo.visible = false;
                            }
                        
                        }
                        Divider {
                        
                        }
                        Container {
                            layout: StackLayout {
                                orientation: LayoutOrientation.LeftToRight
                            
                            }
                            verticalAlignment: VerticalAlignment.Center
                            Label {
                                text: qsTr("Event notes:") + Retranslate.onLanguageChanged
                                verticalAlignment: VerticalAlignment.Center
                            
                            }
                            TextField {
                                id: tfNotes
                                verticalAlignment: VerticalAlignment.Center
                            
                            }
                        }
                        Divider {
                        
                        }
                        DropDown {
                            id: folderField
                            
                            title: qsTr ("Store in calendar:") + Retranslate.onLanguageChanged
                            
                            onSelectedValueChanged: {
                                _calendar.eventEditor.folderId = selectedValue.folderId
                                _calendar.eventEditor.accountId = selectedValue.accountId
                            }
                        }
                       
                Divider {
                
                }
                Container {
                    layout: StackLayout {
                        orientation: LayoutOrientation.LeftToRight

                    }
                    horizontalAlignment: HorizontalAlignment.Center
                    Button {
                        id: btEvent
                        text: qsTr("Create event") + Retranslate.onLanguageChanged
                        onClicked: {
                            _calendar.eventEditor.subject = tfSubject.text;
                            _calendar.eventEditor.location = tfNumber.text;
                            _calendar.eventEditor.body = tfNotes.text;
                            _calendar.eventEditor.startTime = pomdp1.value
                            _calendar.eventEditor.endTime = pomdp2.value
                            _calendar.eventEditor.folderId = folderField.selectedValue.folderId
                            _calendar.eventEditor.accountId = folderField.selectedValue.accountId
                            _calendar.eventEditor.saveEvent()
                            app.showSuccessMessage(qsTr("Calendar item created") + Retranslate.onLanguageChanged)
                            app.save("CalendarAccount", folderField.selectedIndex);
                            tfSubject.text = "";
                            tfNumber.text = "";
                            tfNotes.text = "";
                        }
                        horizontalAlignment: HorizontalAlignment.Center
                        color: Color.DarkGreen

                    }
                    
                    Button {
                        text: qsTr("Clear") + Retranslate.onLanguageChanged
                        onClicked: {
                            tfSubject.text = "";
                            tfNumber.text = "";
                            tfNotes.text = "";
                        }
                        horizontalAlignment: HorizontalAlignment.Center
                        color: Color.Red
                        appearance: ControlAppearance.Plain

                    }
                    
                }

            }
            onCreationCompleted: {
                pomdp2.value = _calendar.ZvysDatum(pomdp1.value, app.read("EventLength",60)*60);
            }

            }   
                attachedObjects: [
                
                    ComponentDefinition {
                        id: emptyOption
                        Option {}
                    },

                    ContactPicker {
                        id:vyberKontakt
                        
                        onContactSelected: 
                        {                                             
                            ddCislo.removeAll();
                            for (var i = 0; i < app.telCislo(contactId).length; i++) {
                                var newOption = emptyOption.createObject()
                                newOption.text = app.telCislo(contactId)[i];
                                ddCislo.add(newOption);
                            }
                            if (app.telCislo(contactId).length > 0)
                            {ddCislo.selectedIndex = 0};
                            ddCislo.visible = true;
                            
                            if (tbEmail.checked) {tfNotes.text=app.eMail(contactId);};
                            tfSubject.text = app.read("EventSubject", "Call contact ") + app.displayName(contactId);
                        }
                    },
                    Sheet {
                        id: myReg
                        
                        content: Page {
                            
                            titleBar: TitleBar {
                                title: "Registration";
                                appearance: TitleBarAppearance.Branded
                            
                            }
                            actions: [
                                ActionItem {
                                    title: qsTr("Close app") + Retranslate.onLocaleOrLanguageChanged
                                    imageSource: "asset:///ic_home.png"
                                    ActionBar.placement: ActionBarPlacement.Signature
                                    
                                    // When this action is selected, close
                                    // the sheet
                                    onTriggered: {
                                        myReg.close();
                                        Application.quit();
                                    }
                                }
                            ]
                            ScrollView {
                                
                                Container {
                                    property real margins: ui.du(3)
                                    
                                    
                                    topPadding: margins
                                    leftPadding: margins
                                    rightPadding: margins
                                    bottomPadding: margins
                                    Label {
                                        text:qsTr("Before further using the app, a small registration fee must be paid.")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("This allows us future development a improving our app. Thank you for understanding.")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("Please follow kindly these simple steps:")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("1. Click Generate code button and send displayed code to yamaco@yamaco.cz")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("2. Click Payment button and make a payment of USD 1 (minimum)")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("3. Enter the code which we'll send you back")
                                        multiline: true
                                    }
                                    Label {
                                        text:qsTr("That's all. Thank you so much for your support.")
                                        multiline: true
                                    }
                                    Button {
                                        
                                        preferredWidth: 80.0
                                        text: qsTr("Generate code")
                                        onClicked: {
                                            lbReg.text=getRandomInt(10000000,90000000);
                                            app.save("RegIn", lbReg.text);
                                        }
                                        rightMargin: 10.0
                                    
                                    
                                    }
                                    Label {
                                        id: lbReg
                                        text:qsTr("")
                                    
                                    }
                                    Button {
                                        
                                        preferredWidth: 80.0
                                        text: qsTr("Payment")
                                        onClicked: {
                                            donate.trigger("bb.action.OPEN")
                                        }
                                        rightMargin: 10.0
                                    
                                    
                                    }
                                    Label {
                                        text:qsTr("If you received the registratin code from us, please enter it here and click Register Button:")
                                        multiline: true
                                    }
                                    TextField {
                                        id: tfRegCode
                                        inputMode: TextFieldInputMode.NumbersAndPunctuation
                                    
                                    }
                                    Button {
                                        
                                        preferredWidth: 80.0
                                        text: qsTr("Register")
                                        onClicked: {
                                            if (tfRegCode.text==app.read("RegIn", "")*2-999)
                                            {dlgRegOk.show();app.save("RegOut", "OK");} else 
                                            {dlgRegNo.show()}   
                                        }
                                        rightMargin: 10.0
                                    
                                    
                                    }
                                
                                
                                }
                            } // end of Container
                        
                        
                        }
                    
                    },
                    Sheet {
                        id: mySettings
                        content: Page {
                            titleBar: TitleBar {
                                title: qsTr("Settings") + Retranslate.onLocaleOrLanguageChanged
                                appearance: TitleBarAppearance.Branded
                            
                            }
                            actions: [
                                ActionItem {
                                    title: qsTr("Back") + Retranslate.onLocaleOrLanguageChanged
                                    imageSource: "asset:///ic_home.png"
                                    ActionBar.placement: ActionBarPlacement.Signature
                                    
                                    // When this action is selected, close
                                    // the sheet
                                    onTriggered: {
                                        if (tbTheme.checked == true) {
                                            Settings.saveValueFor("theme", "dark");
                                        } else {
                                            Settings.saveValueFor("theme", "bright");
                                        };
                                        app.save("EventLength", tfLength.text);
                                        app.save("EventSubject", tfDefSubject.text);
                                        app.save("EmailNotes", tbEmail.checked);
                                        mySettings.close();
                                    }
                                }
                            ]
                            Container {
                        id: cnNastaveni

                        property real margins: ui.du(3)
                                
                                
                                topPadding: margins
                                leftPadding: margins
                                rightPadding: margins
                                bottomPadding: margins
                        ScrollView {
                            Container {
                                Divider {
                                
                                }
                                
                                Container {
                                    verticalAlignment: VerticalAlignment.Top
                                    layout: DockLayout {
                                    
                                    }
                                    horizontalAlignment: HorizontalAlignment.Fill
                                    Label {
                                        text: qsTr("Dark theme") + Retranslate.onLocaleOrLanguageChanged
                                        verticalAlignment: VerticalAlignment.Top
                                    
                                    }
                                    ToggleButton {
                                        id: tbTheme
                                        verticalAlignment: VerticalAlignment.Top
                                        horizontalAlignment: HorizontalAlignment.Right
                                    
                                    }
                                
                                }
                                Divider {
                                
                                }
                                
                                Container {
                                    verticalAlignment: VerticalAlignment.Top
                                    layout: DockLayout {
                                    
                                    }
                                    horizontalAlignment: HorizontalAlignment.Fill
                                    Label {
                                        text: qsTr("Contact email into notes") + Retranslate.onLocaleOrLanguageChanged
                                        verticalAlignment: VerticalAlignment.Top
                                    
                                    }
                                    ToggleButton {
                                        id: tbEmail
                                        verticalAlignment: VerticalAlignment.Top
                                        horizontalAlignment: HorizontalAlignment.Right
                                    
                                    }
                                
                                }
                                Divider {
                                
                                }
                                                                
                                Container {
                                    layout: StackLayout {
                                        orientation: LayoutOrientation.LeftToRight
                                    
                                    }
                                    verticalAlignment: VerticalAlignment.Center
                                    Label {
                                        text: qsTr("Event length (minutes):") + Retranslate.onLanguageChanged
                                        verticalAlignment: VerticalAlignment.Center
                                    
                                    }
                                    TextField {
                                        id: tfLength
                                        inputMode: TextFieldInputMode.NumbersAndPunctuation
                                        verticalAlignment: VerticalAlignment.Center
                                    
                                    }
                                }
                                Divider {
                                
                                }
                                Container {
                                    layout: StackLayout {
                                        orientation: LayoutOrientation.LeftToRight
                                    
                                    }
                                    verticalAlignment: VerticalAlignment.Center
                                    Label {
                                        text: qsTr("Default subject of event:") + Retranslate.onLanguageChanged
                                        verticalAlignment: VerticalAlignment.Center
                                    
                                    }
                                    TextField {
                                        id: tfDefSubject
                                        verticalAlignment: VerticalAlignment.Center
                                    
                                    }
                                }
                                
                            }

                        }

                    }
                    onCreationCompleted: {
                        if (Settings.getValueFor("theme", "bright") == "dark") {
                            tbTheme.checked = true
                        } else {
                            tbTheme.checked = false
                        }
                        tfLength.text = app.read("Eventlength", 60);
                        tbEmail.checked = app.read("EmailNotes", true);
                        tfDefSubject.text = app.read("EventSubject", "Call contact ");
                        if (app.read("RegOut", "")=="")
                        {myReg.open()};
                    }
                }
            }
        ]

    }
    attachedObjects: [
        
        SystemDialog {
            id: aboutDialog
            title: "Info"
            body: "(c) YAMACO Software 2015-2019 \n \n web: www.yamaco.cz \n email: yamaco@yamaco.cz"
            cancelButton.label: ""
        },
        Invocation {
            id: invoke
            query: InvokeQuery {
                mimeType: "text/html"
                uri: "http://appworld.blackberry.com/webstore/vendor/91027/?lang=en&countrycode=CZ"
                invokeActionId: "bb.action.OPEN"
            }
        },
        Invocation {
            id: donate
            query: InvokeQuery {
                mimeType: "text/html"
                uri: "https://yamaco.cz/blackberry-apps-donation.html"
                invokeActionId: "bb.action.OPEN"
            }
        
        },
        SystemDialog {
            id: dlgRegOk
            title: "Info"
            body: "Registration was successful. Thank you and restart the app please."
            cancelButton.label: ""
        }   
        ,
        SystemDialog {
            id: dlgRegNo
            title: "Info"
            body: "Wrong registration code."
            cancelButton.label: ""
        } 

    ]
    
    
    actions: [

        ActionItem {
            title: qsTr("Settings") + Retranslate.onLanguageChanged
            imageSource: "asset:///ic_settings.png"
            ActionBar.placement: ActionBarPlacement.Signature

            onTriggered: {
                mySettings.open();

            }

        },
        ActionItem {
            title: qsTr("Info") + Retranslate.onLanguageChanged
            imageSource: "asset:///ic_info.png"
            ActionBar.placement: ActionBarPlacement.InOverflow

            onTriggered: {
                aboutDialog.show()
            }

        },
        ActionItem {
            title: qsTr("More apps") + Retranslate.onLanguageChanged
            imageSource: "asset:///ic_select_more.png"
            ActionBar.placement: ActionBarPlacement.InOverflow
            onTriggered: {
                invoke.trigger("bb.action.OPEN")
            }

        }


    ]
    
    onCreationCompleted: {
        _calendar.eventEditor.initializeFolderDropDown(folderField);
        folderField.selectedIndex = app.read("CalendarAccount", 0);
    }
    
    function getRandomInt(min, max) {
        min = Math.ceil(min);
        max = Math.floor(max);
        return Math.floor(Math.random() * (max - min)) + min;
    }

    
}

